/*
 *  TypeConstants.c
 */

#include <TypeConstants.h>
#include "bfs.h"


void
Init_TypeConstants()
{
  rb_define_const(mBfs, "ANY_TYPE", UINT2NUM(B_ANY_TYPE));
  rb_define_const(mBfs, "BOOL_TYPE", UINT2NUM(B_BOOL_TYPE));
  rb_define_const(mBfs, "CHAR_TYPE", UINT2NUM(B_CHAR_TYPE));
  rb_define_const(mBfs, "COLOR_8_BIT_TYPE", UINT2NUM(B_COLOR_8_BIT_TYPE));
  rb_define_const(mBfs, "DOUBLE_TYPE", UINT2NUM(B_DOUBLE_TYPE));
  rb_define_const(mBfs, "FLOAT_TYPE", UINT2NUM(B_FLOAT_TYPE));
  rb_define_const(mBfs, "GRAYSCALE_8_BIT_TYPE", UINT2NUM(B_GRAYSCALE_8_BIT_TYPE));
  rb_define_const(mBfs, "INT64_TYPE", UINT2NUM(B_INT64_TYPE));
  rb_define_const(mBfs, "INT32_TYPE", UINT2NUM(B_INT32_TYPE));
  rb_define_const(mBfs, "INT16_TYPE", UINT2NUM(B_INT16_TYPE));
  rb_define_const(mBfs, "INT8_TYPE", UINT2NUM(B_INT8_TYPE));
  rb_define_const(mBfs, "MESSAGE_TYPE", UINT2NUM(B_MESSAGE_TYPE));
  rb_define_const(mBfs, "MESSENGER_TYPE", UINT2NUM(B_MESSENGER_TYPE));
  rb_define_const(mBfs, "MIME_TYPE", UINT2NUM(B_MIME_TYPE));
  rb_define_const(mBfs, "MONOCHROME_1_BIT_TYPE", UINT2NUM(B_MONOCHROME_1_BIT_TYPE));
  rb_define_const(mBfs, "OBJECT_TYPE", UINT2NUM(B_OBJECT_TYPE));
  rb_define_const(mBfs, "OFF_T_TYPE", UINT2NUM(B_OFF_T_TYPE));
  rb_define_const(mBfs, "PATTERN_TYPE", UINT2NUM(B_PATTERN_TYPE));
  rb_define_const(mBfs, "POINTER_TYPE", UINT2NUM(B_POINTER_TYPE));
  rb_define_const(mBfs, "POINT_TYPE", UINT2NUM(B_POINT_TYPE));
  rb_define_const(mBfs, "RAW_TYPE", UINT2NUM(B_RAW_TYPE));
  rb_define_const(mBfs, "RECT_TYPE", UINT2NUM(B_RECT_TYPE));
  rb_define_const(mBfs, "REF_TYPE", UINT2NUM(B_REF_TYPE));
  rb_define_const(mBfs, "RGB_32_BIT_TYPE", UINT2NUM(B_RGB_32_BIT_TYPE));
  rb_define_const(mBfs, "RGB_COLOR_TYPE", UINT2NUM(B_RGB_COLOR_TYPE));
  rb_define_const(mBfs, "SIZE_T_TYPE", UINT2NUM(B_SIZE_T_TYPE));
  rb_define_const(mBfs, "SSIZE_T_TYPE", UINT2NUM(B_SSIZE_T_TYPE));
  rb_define_const(mBfs, "STRING_TYPE", UINT2NUM(B_STRING_TYPE));
  rb_define_const(mBfs, "TIME_TYPE", UINT2NUM(B_TIME_TYPE));
  rb_define_const(mBfs, "UINT64_TYPE", UINT2NUM(B_UINT64_TYPE));
  rb_define_const(mBfs, "UINT32_TYPE", UINT2NUM(B_UINT32_TYPE));
  rb_define_const(mBfs, "UINT16_TYPE", UINT2NUM(B_UINT16_TYPE));
  rb_define_const(mBfs, "UINT8_TYPE", UINT2NUM(B_UINT8_TYPE));
  rb_define_const(mBfs, "MEDIA_PARAMETER_TYPE", UINT2NUM(B_MEDIA_PARAMETER_TYPE));
  rb_define_const(mBfs, "MEDIA_PARAMETER_WEB_TYPE", UINT2NUM(B_MEDIA_PARAMETER_WEB_TYPE));
  rb_define_const(mBfs, "MEDIA_PARAMETER_GROUP_TYPE", UINT2NUM(B_MEDIA_PARAMETER_GROUP_TYPE));

  rb_define_const(mBfs, "URL_HTTP", rb_str_new2(B_URL_HTTP));
  rb_define_const(mBfs, "URL_HTTPS", rb_str_new2(B_URL_HTTPS));
  rb_define_const(mBfs, "URL_FTP", rb_str_new2(B_URL_FTP));
  rb_define_const(mBfs, "URL_GOPHER", rb_str_new2(B_URL_GOPHER));
  rb_define_const(mBfs, "URL_MAILTO", rb_str_new2(B_URL_MAILTO));
  rb_define_const(mBfs, "URL_NEWS", rb_str_new2(B_URL_NEWS));
  rb_define_const(mBfs, "URL_NNTP", rb_str_new2(B_URL_NNTP));
  rb_define_const(mBfs, "URL_TELNET", rb_str_new2(B_URL_TELNET));
  rb_define_const(mBfs, "URL_RLOGIN", rb_str_new2(B_URL_RLOGIN));
  rb_define_const(mBfs, "URL_TN3270", rb_str_new2(B_URL_TN3270));
  rb_define_const(mBfs, "URL_WAIS", rb_str_new2(B_URL_WAIS));
  rb_define_const(mBfs, "URL_FILE", rb_str_new2(B_URL_FILE));
}
