#! /boot/home/config/bin/ruby -d

#
# atr.rb
#

require "bfs.so"
include Bfs


f = File.open("text.txt")

Attr.write(f.fileno, "type:bool",            true)
Attr.write(f.fileno, "type:char",            ?A,           CHAR_TYPE)
Attr.write(f.fileno, "type:double",          0.1)
Attr.write(f.fileno, "type:float",           0.1,          FLOAT_TYPE)
Attr.write(f.fileno, "type:int64",           2**31-1)
Attr.write(f.fileno, "type:int32",           32)
Attr.write(f.fileno, "type:int16",           16,           INT16_TYPE)
Attr.write(f.fileno, "type:int8",             8,           INT8_TYPE)
Attr.write(f.fileno, "type:mime",  "text/plain",           MIME_TYPE)
Attr.write(f.fileno, "type:time",  Time.now)
Attr.write(f.fileno, "type:string",  "Hello!")
Attr.write(f.fileno, "type:mime_string",  "text/plain",    MIME_STRING_TYPE)

p Attr.read(f.fileno, "type:bool")
p Attr.read(f.fileno, "type:char")
p Attr.read(f.fileno, "type:double")
p Attr.read(f.fileno, "type:float")
p Attr.read(f.fileno, "type:int64")
p Attr.read(f.fileno, "type:int32")
p Attr.read(f.fileno, "type:int16")
p Attr.read(f.fileno, "type:int8")
p Attr.read(f.fileno, "type:mime")
p Attr.read(f.fileno, "type:time")
p Attr.read(f.fileno, "type:string")
p Attr.read(f.fileno, "type:mime_string")

Attr.remove(f.fileno, "type:bool")
Attr.remove(f.fileno, "type:char")
Attr.remove(f.fileno, "type:double")
Attr.remove(f.fileno, "type:float")
Attr.remove(f.fileno, "type:int64")
Attr.remove(f.fileno, "type:int32")
Attr.remove(f.fileno, "type:int16")
Attr.remove(f.fileno, "type:int8")
Attr.remove(f.fileno, "type:mime")
Attr.remove(f.fileno, "type:time")
Attr.remove(f.fileno, "type:string")
Attr.remove(f.fileno, "type:mime_string")

f.close
