#! /boot/home/config/bin/ruby -d

#
# people.rb
#
# usage:
#   query '(BEOS:TYPE=application/x-person) && (META:email=*or.jp*)' | ruby people.rb
#

require "bfs.rb"
include Bfs


ARGF.each {| fname |
  fname.strip!

  File.open(fname.gsub(/\\/, nil)) {| f |
    print <<-PEOPLE
file://#{fname}
      Name: #{f.read_attr("META:name")}
  Nickname: #{f.read_attr("META:nickname")}
   Company: #{f.read_attr("META:company")}
   Address: #{f.read_attr("META:address")}
      City: #{f.read_attr("META:city")}
     State: #{f.read_attr("META:state")}
       Zip: #{f.read_attr("META:zip")}
   Country: #{f.read_attr("META:country")}
Home Phone: #{f.read_attr("META:hphone")}
Work Phone: #{f.read_attr("META:wphone")}
       Fax: #{f.read_attr("META:fax")}
    E-mail: #{f.read_attr("META:email")}
       URL: #{f.read_attr("META:url")}
     Group: #{f.read_attr("META:group")}

    PEOPLE
  }
}
